import os
import sys

class Cmd:
  def __init__(self, commandString, fileNameString):
    if(type(commandString) != type(str())):
      print 'ERROR: command not a string'
      commandString = str(commandString)
    if(type(fileNameString) != type(str())):
      print 'ERROR: file name not a string'
      fileNameString = str(fileNameString)
    self.cmd = commandString + ' ' + fileNameString
    
  def do(self):
    print '\n\nExecuting command:', self.cmd
    os.system(self.cmd)
    
def addHyperref(filePath):
  """ Adds hyperref package at just the right spot in the tex file """
  fIN = open(os.path.join(os.path.split(filePath)[0], 'hyperrefSettings.ini'), 'r')
  hyperrefConfigText = fIN.read()
  fIN.close()
  
  fIN = open(filePath, 'r')
  hyperrefPath = filePath[:-4] + '_HREF.tex'
  fOUT = open(hyperrefPath, 'w')
  for line in fIN.readlines():
    if(line[:-1] == '\\floatstyle{ruled}'):
      fOUT.write(hyperrefConfigText + '\n')
    fOUT.write(line)
  
  fIN.close()
  fOUT.close()
  return hyperrefPath
  

# Program starts here
progNameList = ['pdflatex', 'bibtex', 'AcroRd32.exe']

# Check for arguments given at the command-line
if(len(sys.argv) not in [2, 3]):
  print '\nThis script needs ONE argument, the name of latex file'
  print 'Arguments recieved: ', str(sys.argv)
  print '\nFYI: your path environment variable contains the following:', \
        os.getenv('path')
  print '\n\nNow testing these programs:', str(progNameList )  

  for prog in progNameList:
    print '\nTesting: ', prog
    ans = raw_input('Press q to quit, any key to continue: ')
    if(ans == 'q' or ans == 'Q'):
      sys.exit()
    if(prog == 'latex'):
      print '\nPress q then enter to exit latex\n'
    os.system(prog)  
      
else:
  # NORMAL usage case: PDF --> View PDF with Acrobat
  filename = sys.argv[1]
  filename = os.path.splitext(filename)[0] # 'myFile.tex' --> 'myFile'
  filename = addHyperref(os.path.join(os.getcwd(), filename + '.tex'))

  pdfCmd = Cmd(progNameList[0], filename)
  pdfCmd.do()
  
  
  # Cheap trick to do a second pdflatex pass if a 3rd dummy argument is given
  if(len(sys.argv) == 3):
    bibCmd = Cmd(progNameList[1], os.path.splitext(filename)[0])
    bibCmd.do()
    pdfCmd.do()
    pdfCmd.do()
  
  filename = os.path.splitext(filename)[0] # 'myFile.tex' --> 'myFile'
  readCmd = Cmd(progNameList[2], os.path.join(os.getcwd(), filename + '.pdf'))
  readCmd.do()
  
  print '\n\n'
  print 'Latex script terminated. For help use no arguments: ', sys.argv[0]
  
